diff -Nur madwifi-trunk-r3314.orig/ath/if_ath.c madwifi-trunk-r3314/ath/if_ath.c
--- madwifi-trunk-r3314.orig/ath/if_ath.c	2008-07-12 21:31:08.000000000 +0200
+++ madwifi-trunk-r3314/ath/if_ath.c	2008-07-12 21:49:33.000000000 +0200
@@ -6331,7 +6331,7 @@
 
 	/* Never copy the SKB, as it is ours on the RX side, and this is the 
 	 * last process on the TX side and we only modify our own headers. */
-	tskb = ath_skb_removepad(skb, 0 /* Copy SKB */);
+	tskb = ath_skb_removepad(skb, !tx /* Copy SKB */);
 	if (tskb == NULL) {
 		DPRINTF(sc, ATH_DEBUG_ANY,
 			"Dropping; ath_skb_removepad failed!\n");
@@ -6339,6 +6339,8 @@
 	}
 	
 	ieee80211_input_monitor(ic, tskb, bf, tx, tsf, sc);
+	if (tskb != skb)
+		ieee80211_dev_kfree_skb(&tskb);
 }
 
 /*
